/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Terminfo.xs. Do not edit this file, edit Terminfo.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Term/Terminfo.xs"
/*  You may distribute under the terms of either the GNU General Public License
 *  or the Artistic License (the same terms as Perl itself)
 *
 *  (C) Paul Evans, 2009 -- leonerd@leonerd.org.uk
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef HAVE_UNIBILIUM
# include <unibilium.h>
#else
# include <term.h>
#endif

static void load_terminfo(const char *termtype,
  HV *flags_by_capname, HV *nums_by_capname, HV *strs_by_capname,
  HV *flags_by_varname, HV *nums_by_varname, HV *strs_by_varname
)
{
  int i;
  SV *sv;

#ifdef HAVE_UNIBILIUM
  unibi_term *unibi = unibi_from_term(termtype);
  if(!unibi) {
    croak("unibi_from_term(\"%s\"): %s", termtype, strerror(errno));
  }
#else
  TERMINAL *oldterm = cur_term;
  setupterm(termtype, 0, NULL);
#endif

#ifdef HAVE_UNIBILIUM
  for(i = unibi_boolean_begin_+1; i < unibi_boolean_end_; i++)
#else
  for(i = 0; boolnames[i]; i++)
#endif
  {
#ifdef HAVE_UNIBILIUM
    const char *capname = unibi_short_name_bool(i);
    const char *varname = unibi_name_bool(i);
    int value = unibi_get_bool(unibi, i);
#else
    const char *capname = boolnames[i];
    const char *varname = boolfnames[i];
    int value = tigetflag(capname);
#endif

    if(!value)
      continue;

    sv = newSViv(1);
    SvREADONLY_on(sv);

    hv_store(flags_by_capname, capname, strlen(capname), sv, 0);
    hv_store(flags_by_varname, varname, strlen(varname), SvREFCNT_inc(sv), 0);
  }

#ifdef HAVE_UNIBILIUM
  for(i = unibi_numeric_begin_+1; i < unibi_numeric_end_; i++)
#else
  for(i = 0; numnames[i]; i++)
#endif
  {
#ifdef HAVE_UNIBILIUM
    const char *capname = unibi_short_name_num(i);
    const char *varname = unibi_name_num(i);
    int value = unibi_get_num(unibi, i);
#else
    const char *capname = numnames[i];
    const char *varname = numfnames[i];
    int value = tigetnum(capname);
#endif

    if(value == -1)
      continue;

    sv = newSViv(value);
    SvREADONLY_on(sv);

    hv_store(nums_by_capname, capname, strlen(capname), sv, 0);
    hv_store(nums_by_varname, varname, strlen(varname), SvREFCNT_inc(sv), 0);
  }

#ifdef HAVE_UNIBILIUM
  for(i = unibi_string_begin_+1; i < unibi_string_end_; i++)
#else
  for(i = 0; strnames[i]; i++)
#endif
  {
#ifdef HAVE_UNIBILIUM
    const char *capname = unibi_short_name_str(i);
    const char *varname = unibi_name_str(i);
    const char *value = unibi_get_str(unibi, i);
#else
    const char *capname = strnames[i];
    const char *varname = strfnames[i];
    const char *value = tigetstr(capname);
#endif

    if(!value)
      continue;

    sv = newSVpv(value, 0);
    SvREADONLY_on(sv);

    hv_store(strs_by_capname, capname, strlen(capname), sv, 0);
    hv_store(strs_by_varname, varname, strlen(varname), SvREFCNT_inc(sv), 0);
  }

#ifdef HAVE_UNIBILIUM
  unibi_destroy(unibi);
#else
  oldterm = set_curterm(oldterm);
  del_curterm(oldterm);
#endif
}

#line 131 "lib/Term/Terminfo.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 275 "lib/Term/Terminfo.c"

XS_EUPXS(XS_Term__Terminfo__init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Term__Terminfo__init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV *	self;
#line 128 "lib/Term/Terminfo.xs"
    char *termtype;
    HV *flags_by_capname, *nums_by_capname, *strs_by_capname;
    HV *flags_by_varname, *nums_by_varname, *strs_by_varname;

#line 290 "lib/Term/Terminfo.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Term::Terminfo::_init",
				"self");
		}
	} STMT_END
;
#line 133 "lib/Term/Terminfo.xs"
    termtype = SvPV_nolen(*hv_fetch(self, "term", 4, 0));

    flags_by_capname = newHV();
    nums_by_capname  = newHV();
    strs_by_capname  = newHV();

    flags_by_varname = newHV();
    nums_by_varname  = newHV();
    strs_by_varname  = newHV();

    load_terminfo(termtype,
      flags_by_capname, nums_by_capname, strs_by_capname,
      flags_by_varname, nums_by_varname, strs_by_varname
    );

    hv_store(self, "flags_by_capname", 16, newRV_noinc((SV*)flags_by_capname), 0);
    hv_store(self, "nums_by_capname",  15, newRV_noinc((SV*)nums_by_capname),  0);
    hv_store(self, "strs_by_capname",  15, newRV_noinc((SV*)strs_by_capname),  0);

    hv_store(self, "flags_by_varname", 16, newRV_noinc((SV*)flags_by_varname), 0);
    hv_store(self, "nums_by_varname",  15, newRV_noinc((SV*)nums_by_varname),  0);
    hv_store(self, "strs_by_varname",  15, newRV_noinc((SV*)strs_by_varname),  0);

    XSRETURN_UNDEF;
#line 330 "lib/Term/Terminfo.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Term__Terminfo); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Term__Terminfo)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Term::Terminfo::_init", XS_Term__Terminfo__init);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

